blob: 6591ce653b0f3016e9c86f86ef311dc08ca375f9 [file] [log] [blame]
Petr Michalec1ed1b3c2017-08-08 19:19:01 +02001#!/bin/bash -e
2
3# bootstrap.sh
4
5# Installs Salt and configure minimal SaltMaster or Minion to be used with:
6# - http://github.com/salt-formulas-scripts
7# - http://github.com/salt-formulas/salt-formula-salt (salt.master sls)
8
9# TODO:
10# - use PPA repository as formula source
11# - support for spm/yum
12
13
14# Source specific env vars.
15# shopt -u dotglob
16export RECLASS_ROOT=${RECLASS_ROOT:-/srv/salt/reclass}
17function source_local_envs() {
Petr Michalecb444ef92017-08-17 13:53:14 +020018 for path in / /tmp/kitchen /srv/salt . ${RECLASS_ROOT}/classes/cluster ${RECLASS_ROOT}/classes/cluster/${CLUSTER_NAME}; do
Vasyl Saienko7a4161c2017-08-14 17:43:15 +030019 for f in $(find $path -maxdepth 1 -name '*.env' 2> /dev/null); do
20 echo "Sourcing env variables from $f"
21 source $f
22 done
23 done
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020024}
25source_local_envs
26
27##########################################
28# Set defaults env variables
29
30if [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
31 set -x
32 SALT_LOG_LEVEL="--state-verbose=true -ldebug"
33fi
34
35export MAGENTA='\033[0;95m'
36export YELLOW='\033[1;33m'
37export BLUE='\033[0;35m'
38export CYAN='\033[0;96m'
39export RED='\033[0;31m'
40export NC='\033[0m' # No Color'
41
42export LC_ALL=C
43export SALT_LOG_LEVEL="--state-verbose=false -lerror"
44export SALT_OPTS="${SALT_OPTS:- --timeout=120 --state-output=changes --retcode-passthrough --force-color $SALT_LOG_LEVEL }"
45export SALT_STATE_RETRY=${SALT_STATE_RETRY:-3}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020046
47
48# salt apt repository
49test -e /etc/lsb-release && eval $(cat /etc/lsb-release)
50which lsb_release && DISTRIB_CODENAME=${DISTRIB_CODENAME:-$(lsb_release -cs)}
51#
chnyda30c07a62017-09-20 14:28:02 +020052export APT_REPOSITORY="deb [arch=amd64] http://apt.mirantis.com/${DISTRIB_CODENAME} ${DISTRIB_REVISION:-stable} salt"
53export APT_REPOSITORY_GPG=${APT_REPOSITORY_GPG:-http://apt.mirantis.com/public.gpg}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020054
55# reclass
56export RECLASS_ADDRESS=${RECLASS_ADDRESS:-https://github.com/salt-formulas/openstack-salt.git} # https/git
57
58# formula
59export FORMULAS_BASE=${FORMULAS_BASE:-https://github.com/salt-formulas}
60export FORMULAS_PATH=${FORMULAS_PATH:-/usr/share/salt-formulas}
61export FORMULAS_BRANCH=${FORMULAS_BRANCH:-master}
62export FORMULAS_SOURCE=${FORMULAS_SOURCE:-pkg} # pkg/git
63# essential set of formulas (known to by used on cfg01 node for most setups)
chnyda86d63b42017-08-31 10:05:00 +020064FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS memcached openssh ntp nginx collectd sensu heka sphinx mysql grafana libvirt rsyslog glusterfs postfix xtrabackup freeipa prometheus telegraf elasticsearch kibana rundeck devops-portal rsync docker keepalived aptly jenkins gerrit artifactory influxdb}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020065# minimal set of formulas for salt-master bootstrap
66declare -a FORMULAS_SALT_MASTER=(linux reclass salt git $(echo $FORMULAS_SALT_MASTER))
67export FORMULAS_SALT_MASTER
68
69# system / host
Petr Michalecc749e862017-09-06 21:10:10 +020070export HOSTNAME=${HOSTNAME:-`hostname -s`}
71export HOSTNAME=${HOSTNAME//.*/}
72export DOMAIN=${DOMAIN:-`hostname -d`}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020073export DOMAIN=${DOMAIN:-bootstrap.local}
74
75# salt
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020076export MINION_ID=${MINION_ID:-${HOSTNAME}.${DOMAIN}}
Petr Michalec2e3a4992017-08-17 14:20:43 +020077export MASTER_HOSTNAME=${MASTER_HOSTNAME:-${HOSTNAME}.${DOMAIN}}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020078
79# saltstack
Petr Michalec33c04892017-09-08 15:10:30 +020080BOOTSTRAP_SALTSTACK=${BOOTSTRAP_SALTSTACK:-True}
Petr Michalece11cf612017-09-08 18:21:48 +020081BOOTSTRAP_SALTSTACK_VERSION=${BOOTSTRAP_SALTSTACK_VERSION:- stable 2016.3 }
Petr Michalec33c04892017-09-08 15:10:30 +020082BOOTSTRAP_SALTSTACK_OPTS=${BOOTSTRAP_SALTSTACK_OPTS:- -dX $BOOTSTRAP_SALTSTACK_VERSION }
Petr Michalece11cf612017-09-08 18:21:48 +020083SALT_SOURCE=${SALT_SOURCE:-pkg}
84# the version below is used salt pillar data
85SALT_VERSION=${SALT_VERSION:-latest}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020086
87# environment
88if [ "$FORMULAS_SOURCE" == "git" ]; then
89 SALT_ENV=${SALT_ENV:-dev}
90elif [ "$FORMULAS_SOURCE" == "pkg" ]; then
91 SALT_ENV=${SALT_ENV:-prd}
92fi
Petr Michalec05b52452017-09-08 14:26:59 +020093eval "$(grep -h '=' /etc/*release 2> /dev/null)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020094PLATFORM_FAMILY=$(echo ${ID_LIKE// */} | tr A-Z a-z)
95case $PLATFORM_FAMILY in
96 debian )
97 PKGTOOL="$SUDO apt-get"
98 test ${VERSION_ID//\.*/} -ge 16 && {
99 SVCTOOL=service
100 } || { SVCTOOL=service
101 }
102 ;;
103 rhel )
104 PKGTOOL="$SUDO yum"
105 test ${VERSION_ID//\.*/} -ge 7 && {
106 SVCTOOL=systemctl
107 } || { SVCTOOL=service
108 }
109 ;;
110esac
111
112export PLATFORM_FAMILY
113export PKGTOOL
114export SVCTOOL
115
116##########################################
117# FUNCTIONS
118
119log_info() {
120 echo -e "${YELLOW}[INFO] $* ${NC}"
121}
122
123log_warn() {
124 echo -e "${MAGENTA}[WARN] $* ${NC}"
125}
126
Petr Michalec24b30e82017-08-21 10:59:18 +0200127log_debug() {
128 echo -e "${CYAN}[WARN] $* ${NC}"
129}
130
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200131log_err() {
132 echo -e "${RED}[ERROR] $* ${NC}" >&2
133}
134
135configure_pkg_repo()
136{
137
138 case $PLATFORM_FAMILY in
139 debian)
140 if [ -n "$APT_REPOSITORY_PPA" ]; then
141 which add-apt-repository || $SUDO apt-get install -y software-properties-common
142 $SUDO add-apt-repository -y ppa:${APT_REPOSITORY_PPA}
143 else
144 echo -e "$APT_REPOSITORY " | $SUDO tee /etc/apt/sources.list.d/bootstrap.list >/dev/null
145 curl -sL $APT_REPOSITORY_GPG | $SUDO apt-key add -
146 fi
147 $SUDO apt-get clean
148 $SUDO apt-get update
149 ;;
150 rhel)
151 $SUDO yum install -y https://repo.saltstack.com/yum/redhat/salt-repo-latest-1.el${VERSION_ID}.noarch.rpm
152 $SUDO yum clean all
153 ;;
154 esac
155
156}
157
158_atexit() {
159 RETVAL=$?
160 trap true INT TERM EXIT
161
162 if [ $RETVAL -ne 0 ]; then
163 log_err "Execution failed"
164 else
165 log_info "Execution successful"
166 fi
167 return $RETVAL
168}
169
170retry() {
171 local tries
172 if [[ $1 =~ ^[0-9]+$ ]]; then
173 tries=$1; shift
174 else
175 tries=3
176 fi
177 for i in $(seq 1 $tries); do
178 "$@" && return 0 || sleep $i
179 done
180 return 1
181}
182
183function clone_reclass() {
Petr Michaleca361d4e2017-09-08 11:38:16 +0200184 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200185 # No reclass at all, clone from given address
186 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
187 if echo ${RECLASS_BRANCH:-master} | egrep -q "^refs"; then
188 git clone ${RECLASS_ADDRESS} ${RECLASS_ROOT}
189 cd ${RECLASS_ROOT}
190 git fetch ${RECLASS_ADDRESS} ${RECLASS_BRANCH:-master} && git checkout FETCH_HEAD
191 cd -
192 else
193 git clone -b ${RECLASS_BRANCH:-master} ${RECLASS_ADDRESS} ${RECLASS_ROOT};
194 fi;
195 fi;
Petr Michalec679f15b2017-09-18 16:16:29 +0200196 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michaleca361d4e2017-09-08 11:38:16 +0200197 log_err "Reclass ${RECLASS_ROOT} is not fetched locally;"
198 ls -Rla ${RECLASS_ROOT}
199 exit 1
200 fi;
201 $SUDO mkdir -p $RECLASS_ROOT/classes/service
202 $SUDO mkdir -p $RECLASS_ROOT/nodes/_generated
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200203}
204
205
206##########################################
207# Main calls
208
Petr Michalecda014202017-08-18 11:26:07 +0200209system_config_ssh_conf() {
210 for conf in ~/.ssh/config /root/.ssh/config; do
211 $SUDO mkdir -p $(dirname $conf)
212 if ! grep StrictHostKeyChecking $conf; then
213 # this should be used only in CI environment
214 echo -e "Host *\n\tStrictHostKeyChecking no\n" | $SUDO tee $conf >/dev/null
215 fi
216 done
217 if ! grep github.com ~/.ssh/known_hosts; then
218 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
219 fi
220}
221
222system_config_salt_modules_prereq() {
223 # salt-formulas custom modules dependencies, etc:
224 $SUDO $PKGTOOL install -y iproute2 curl sudo apt-transport-https python-psutil python-apt python-m2crypto python-oauth python-pip &>/dev/null
225}
226
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200227system_config_minion() {
228 log_info "System configuration salt minion"
229}
230
231system_config_master() {
232 log_info "System configuration salt master"
233
Petr Michalecda014202017-08-18 11:26:07 +0200234 system_config_salt_modules_prereq
235 system_config_ssh_conf
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200236
Petr Michalecda014202017-08-18 11:26:07 +0200237 if ! grep '127.0.1.2.*salt' /etc/hosts; then
238 echo "127.0.1.2 salt" | $SUDO tee -a /etc/hosts >/dev/null
239 fi
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200240
241 which reclass || $SUDO $PKGTOOL install -y reclass
242
243 which reclass-salt || {
244 test -e /usr/share/reclass/reclass-salt && {
245 ln -fs /usr/share/reclass/reclass-salt /usr/bin
246 }
247 }
248}
249
250configure_salt_master()
251{
252
253 echo "Configuring salt-master ..."
254
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200255 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
256 IGNORE_CLASS_NOTFOUND="ignore_class_notfound: True"
257 fi
258
Petr Michalecdd1a0472017-09-06 19:27:24 +0200259 # to force alternative reclass module path
Petr Michalecd9d0a322017-09-06 19:38:32 +0200260 if [ -n "$RECLASS_SOURCE_PATH" ]; then
261 RECLASS_SOURCE_PATH="reclass_source_path: ${RECLASS_SOURCE_PATH}"
262 else
263 RECLASS_SOURCE_PATH=""
264 fi
Petr Michalecdd1a0472017-09-06 19:27:24 +0200265
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200266 [ ! -d /etc/salt/master.d ] && mkdir -p /etc/salt/master.d
267 cat <<-EOF > /etc/salt/master.d/master.conf
268 file_roots:
269 base:
270 - /usr/share/salt-formulas/env
271 prd:
272 - /srv/salt/env/prd
273 dev:
274 - /srv/salt/env/dev
275 pillar_opts: False
276 open_mode: True
277 reclass: &reclass
278 storage_type: yaml_fs
279 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200280 ${IGNORE_CLASS_NOTFOUND}
Petr Michalecdd1a0472017-09-06 19:27:24 +0200281 ${RECLASS_SOURCE_PATH}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200282 ext_pillar:
283 - reclass: *reclass
284 master_tops:
285 reclass: *reclass
286EOF
287
288 echo "Configuring reclass ..."
289
290 [ ! -d /etc/reclass ] && mkdir /etc/reclass
291 cat <<-EOF > /etc/reclass/reclass-config.yml
292 storage_type: yaml_fs
293 pretty_print: True
294 output: yaml
295 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200296 ${IGNORE_CLASS_NOTFOUND}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200297EOF
298
299 clone_reclass
300 # override some envs from cluster level *.env, use with care
301 source_local_envs
302
303 cd ${RECLASS_ROOT}
304 if [ ! -d ${RECLASS_ROOT}/classes/system/linux ]; then
305 # Possibly subrepo checkout needed
306 git submodule update --init --recursive
307 fi
308
Petr Michalec212cc6a2017-08-17 21:39:40 +0200309 mkdir -vp ${RECLASS_ROOT}/nodes/_generated
Petr Michalec51ece842017-09-06 20:44:15 +0200310 rm -rvf ${RECLASS_ROOT}/nodes/_generated/*
311
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200312 CONFIG=$(find ${RECLASS_ROOT}/nodes -name ${MINION_ID}.yml| grep yml | tail -n1)
Petr Michalec212cc6a2017-08-17 21:39:40 +0200313 CONFIG=${CONFIG:-${RECLASS_ROOT}/nodes/_generated/${MINION_ID}.yml}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200314 if [[ $SALT_MASTER_BOOTSTRAP_MINIMIZED =~ ^(True|true|1|yes)$ || ! -f "${CONFIG}" ]]; then
Petr Michalec24b30e82017-08-21 10:59:18 +0200315 log_warn "Salt Master node specification has not been found in model."
316 log_warn "Creating temporary cfg01 configuration for bootstrap: ${CONFIG}"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200317 cat <<-EOF > ${CONFIG}
318 classes:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200319 - cluster.${CLUSTER_NAME}.infra.config
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200320 parameters:
321 _param:
Petr Michaleca7de6df2017-08-31 12:16:57 +0200322 salt_master_host: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200323 salt_master_base_environment: $SALT_ENV
Petr Michalecd81d1f52017-08-17 20:18:06 +0200324 salt_formula_branch: ${SALT_FORMULAS_BRANCH:-master}
325 reclass_data_revision: ${RECLASS_BRANCH:-master}
326 reclass_data_repository: "$RECLASS_ADDRESS"
Petr Michaleca7de6df2017-08-31 12:16:57 +0200327 reclass_config_master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalecd81d1f52017-08-17 20:18:06 +0200328 linux_system_codename: ${DISTRIB_CODENAME}
329 cluster_name: ${CLUSTER_NAME}
330 cluster_domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200331 linux:
332 system:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200333 name: ${HOSTNAME:-cfg01}
334 domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200335 # ########
336EOF
337
338 if [ "$SALT_VERSION" == "latest" ]; then
339 VERSION=""
340 else
341 VERSION="version: $SALT_VERSION"
342 fi
343
344 cat <<-EOF >> ${CONFIG}
345 salt:
346 master:
347 accept_policy: open_mode
348 source:
349 engine: $SALT_SOURCE
350 $VERSION
351 minion:
352 source:
353 engine: $SALT_SOURCE
354 $VERSION
355 # ########
356 # vim: ft=yaml sw=2 ts=2 sts=2
357EOF
358 fi
Petr Michalec24b30e82017-08-21 10:59:18 +0200359
360 log_debug "Salt Master node config yaml:"
361 log_debug "$(cat ${CONFIG})"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200362}
363
364configure_salt_minion()
365{
366 [ ! -d /etc/salt/minion.d ] && mkdir -p /etc/salt/minion.d
367 cat <<-EOF > /etc/salt/minion.d/minion.conf
Petr Michaleca7de6df2017-08-31 12:16:57 +0200368 master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200369 id: $MINION_ID
370 EOF
371}
372
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200373install_reclass()
374{
375 VERSION=${1:-$RECLASS_VERSION}
376 VERSION=${VERSION:-master}
377 # tries to replace all local version system version
378 for s in $(python -c "import site; print(' '.join(site.getsitepackages()))"); do
Petr Michaleca2f351c2017-09-07 17:37:44 +0200379 sudo -H pip install --upgrade --force-reinstall -I \
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200380 -t "$s" git+https://github.com/salt-formulas/reclass.git@${VERSION};
381 done
382}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200383
384install_salt_master_pkg()
385{
386 echo -e "\nPreparing base OS repository ...\n"
387
388 configure_pkg_repo
389
390 echo -e "\nInstalling salt master ...\n"
391
392 case $PLATFORM_FAMILY in
393 debian)
394 $SUDO apt-get install -y git
395 which reclass || $SUDO apt install -qqq -y reclass
396 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
397 ;;
398 rhel)
399 yum install -y git
400 which reclass || $SUDO yum install -y reclass
401 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
402 ;;
403 esac
404
405 which reclass-salt || {
406 test -e /usr/share/reclass/reclass-salt && {
407 ln -fs /usr/share/reclass/reclass-salt /usr/bin
408 }
409 }
410
411 configure_salt_master
412
413 echo -e "\nRestarting services ...\n"
414 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
415 $SVCTOOL salt-master restart
416}
417
418install_salt_master_pip()
419{
420 echo -e "\nPreparing base OS repository ...\n"
421
422 case $PLATFORM_FAMILY in
423 debian)
424 $SUDO apt-get install -y python-pip python-dev zlib1g-dev git
425 which reclass || $SUDO apt-get install -y reclass
426 ;;
427 rhel)
428 $SUDO yum install -y git
429 which reclass || $SUDO yum install -y reclass
430 ;;
431 esac
432
433 echo -e "\nInstalling salt master ...\n"
434 # TODO: replace with saltstack bootstrap script
435
436 if [ "$SALT_VERSION" == "latest" ]; then
437 pip install salt
438 else
439 pip install salt==$SALT_VERSION
440 fi
441
442 curl -Lo /etc/init.d/salt-master https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-master.init && chmod 755 /etc/init.d/salt-master
443 ln -s /usr/local/bin/salt-master /usr/bin/salt-master
444
445 which reclass-salt || {
446 test -e /usr/share/reclass/reclass-salt && {
447 ln -fs /usr/share/reclass/reclass-salt /usr/bin
448 }
449 }
450
451 configure_salt_master
452
453 echo -e "\nRestarting services ...\n"
454 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
455 $SVCTOOL salt-master restart
456}
457
458
459
460install_salt_minion_pkg()
461{
462
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200463 echo -e "\nInstalling salt minion ...\n"
464
465 case $PLATFORM_FAMILY in
466 debian)
467 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
468 ;;
469 rhel)
470 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
471 ;;
472 esac
473
474
475 configure_salt_minion
Petr Michalec3b7fdd82017-09-08 15:35:56 +0200476 #$SVCTOOL salt-minion restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200477}
478
479install_salt_minion_pip()
480{
481 echo -e "\nInstalling salt minion ...\n"
482
483 curl -Lo /etc/init.d/salt-minion https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-minion.init && chmod 755 /etc/init.d/salt-minion
484 ln -s /usr/local/bin/salt-minion /usr/bin/salt-minion
485
486 configure_salt_minion
Petr Michalec3b7fdd82017-09-08 15:35:56 +0200487 #$SVCTOOL salt-minion restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200488}
489
490
491install_salt_formula_pkg()
492{
493 configure_pkg_repo
494
495 case $PLATFORM_FAMILY in
496 debian)
497 echo "Configuring necessary formulas ..."
498
499 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
500 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
501 [ -z ${FORMULAS_SALT_MASTER+x} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
502 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
503 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
504 [ ! -d "${FORMULAS_PATH}/env/${formula_service}" ] && \
505 if ! $SUDO apt-get install -y salt-formula-${formula_service}; then
506 echo -e "\nInstall salt-formula-${formula_service} failed.\n"
507 exit 1
508 fi
509 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
510 ln -sf ${FORMULAS_PATH}/reclass/service/${formula_service} ${RECLASS_ROOT}/classes/service/${formula_service}
511 done
512 ;;
513 rhel)
514 # TODO
515 ;;
516 esac
517
518 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
519 [ ! -L /srv/salt/env/prd ] && ln -s ${FORMULAS_PATH}/env /srv/salt/env/prd || echo ""
520}
521
522install_salt_formula_git()
523{
524 echo "Configuring necessary formulas ..."
525
526 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
527 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
528 [ -z ${FORMULAS_SALT_MASTER+x} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
529 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
530 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
531 _BRANCH=${FORMULAS_BRANCH}
532 [ ! -d "${FORMULAS_PATH}/env/_formulas/${formula_service}" ] && {
533 if ! git ls-remote --exit-code --heads ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${_BRANCH}; then
534 # Fallback to the master branch if the branch doesn't exist for this repository
535 _BRANCH=master
536 fi
537 if ! git clone ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${FORMULAS_PATH}/env/_formulas/${formula_service} -b ${_BRANCH}; then
538 echo -e "\nCloning of ${FORMULAS_BASE}/salt-formula-${formula_service}.git failed.\n"
539 exit 1
540 fi
541 } || {
542 cd ${FORMULAS_PATH}/env/_formulas/${formula_service};
543 git fetch origin/${_BRANCH} || git fetch --all
544 git checkout ${_BRANCH} && git pull || git pull;
545 cd -
546 }
547 [ ! -L "/usr/share/salt-formulas/env/${formula_service}" ] && \
548 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/${formula_service} /usr/share/salt-formulas/env/${formula_service}
549 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
550 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/metadata/service ${RECLASS_ROOT}/classes/service/${formula_service}
551 done
552
553 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
554 [ ! -L /srv/salt/env/dev ] && ln -s /usr/share/salt-formulas/env /srv/salt/env/dev || echo ""
555}
556
557
558saltmaster_bootstrap() {
559
560 log_info "Salt master setup"
561 test -n "$MASTER_HOSTNAME" || exit 1
562
563 clone_reclass
564 # override some envs from cluster level *.env, use with care
565 source_local_envs
566
567 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {}
568 pkill -9 salt-minion
569 test -e ${SCRIPTS}/.salt-master-setup.sh.passed || {
Adam Tengler035f24f2017-09-11 19:29:31 +0200570 export MASTER_IP=${MASTER_IP:-127.0.0.1}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200571 export MINION_ID=${MASTER_HOSTNAME}
572 if ! [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
573 SALT_MASTER_SETUP_OUTPUT='/dev/stdout'
574 fi
575 # call local "setup() master"
576 #if ! $SUDO ${SCRIPTS}/salt-master-setup.sh master &> ${SALT_MASTER_SETUP_OUTPUT:-/tmp/salt-master-setup.log}; then
577 if ! setup master; then
578 #cat /tmp/salt-master-setup.log
579 log_err "salt master setup() failed."
580 exit 1
581 else
582 $SUDO touch ${SCRIPTS}/.salt-master-setup.sh.passed
583 fi
584 }
585
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200586 if [[ $RECLASS_VERSION =~ ^(dev|devel|master)$ ]]; then
Petr Michalec2f9a35b2017-09-07 17:08:06 +0200587 log_warn "Install development version of reclass"
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200588 install_reclass ${RECLASS_VERSION/dev*/master}
589 fi
590
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200591 log_info "Re/starting salt services"
592 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {}
593 pkill -9 salt-minion
594 sleep 1
595 $SUDO service salt-master restart
596 $SUDO service salt-minion restart
597 sleep 10
598}
599
600# Init salt master
601saltmaster_init() {
602
603 log_info "Runing saltmaster states"
604 test -n "$MASTER_HOSTNAME" || exit 1
605
606 set -e
607 $SUDO salt-call saltutil.sync_all >/dev/null
608
609 # TODO: Placeholder update saltmaster spec (nodes/FQDN.yml) to be able to bootstrap with minimal configuration
610 # (ie: with linux, git, salt formulas)
611
612 #log_info "Verify SaltMaster, before salt-master is fully initialized"
613 #if ! $SUDO reclass-salt -p ${MASTER_HOSTNAME} &> /tmp/${MASTER_HOSTNAME}.pillar;then
614 # log_warn "Node verification before initialization failed."; cat /tmp/${MASTER_HOSTNAME}.pillar;
615 #fi
616
Petr Michalecda014202017-08-18 11:26:07 +0200617
618 # workarond isolated and not fully bootstraped environments
Petr Michalec571d6b82017-08-18 13:25:24 +0200619 PILLAR='{"salt":{"master":{"pillar":{"reclass":{"ignore_class_notfound": "'${RECLASS_IGNORE_CLASS_NOTFOUND:-False}'"}}}}, "reclass":{"storage":{"data_source":{"engine":"local"}}} }'
Petr Michalecda014202017-08-18 11:26:07 +0200620
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200621 log_info "State: salt.master.env"
Petr Michalecda014202017-08-18 11:26:07 +0200622 if ! $SUDO salt-call ${SALT_OPTS} -linfo state.apply salt.master.env pillar="$PILLAR"; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200623 log_err "State salt.master.env failed, keep your eyes wide open."
624 fi
625
626 log_info "State: salt.master.pillar"
Petr Michalecda014202017-08-18 11:26:07 +0200627 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.pillar pillar="$PILLAR"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200628 # Note: sikp reclass data dir states
629 # in order to avoid pull from configured repo/branch
630
631 # Revert temporary SaltMaster minimal configuration, if any
632 pushd $RECLASS_ROOT
633 if [ $(git diff --name-only nodes | sort | uniq | wc -l) -ge 1 ]; then
634 git status || true
Petr Michalecda014202017-08-18 11:26:07 +0200635 log_warn "Locally modified $RECLASS_ROOT/nodes found. (Possibly salt-master minimized setup from bootstrap.sh call)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200636 log_info "Checkout HEAD state of $RECLASS_ROOT/nodes/*."
637 git checkout -- $RECLASS_ROOT/nodes || true
638 log_info "Re-Run states: salt.master.env and salt.master.pillar according the HEAD state."
639 log_info "State: salt.master.env"
Petr Michalecda014202017-08-18 11:26:07 +0200640 if ! $SUDO salt-call ${SALT_OPTS} -linfo state.apply salt.master.env pillar="$PILLAR"; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200641 log_err "State salt.master.env failed, keep your eyes wide open."
642 fi
643 log_info "State: salt.master.pillar"
Petr Michalecda014202017-08-18 11:26:07 +0200644 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.pillar pillar="$PILLAR"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200645 fi
646 popd
647
Petr Michalecda014202017-08-18 11:26:07 +0200648 # finally re-configure salt master conf, ie: may remove ignore_class_notfound option
649 log_info "State: salt.master.service"
Petr Michalec7f3e7e72017-08-18 13:49:24 +0200650 $SUDO salt-call ${SALT_OPTS} state.apply salt.master.service || true
Petr Michalecda014202017-08-18 11:26:07 +0200651
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200652 log_info "State: salt.master.storage.node"
653 set +e
Petr Michaleca5141342017-08-16 12:55:20 +0200654 # TODO: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT.
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200655 $SUDO salt-call ${SALT_OPTS} state.apply reclass.storage.node
656 ret=$?
657 set -e
658
659 if [[ $ret -eq 2 ]]; then
660 log_err "State reclass.storage.node failed with exit code 2 but continuing."
661 elif [[ $ret -ne 0 ]]; then
662 log_err "State reclass.storage.node failed with exit code $ret"
663 exit 1
664 fi
665
666 log_info "Re/starting salt services"
667 $SUDO sed -i 's/^master:.*/master: localhost/' /etc/salt/minion.d/minion.conf
Petr Michalecc0bfa972017-09-08 15:21:01 +0200668 $SUDO service salt-minion stop
669 $SUDO service salt-master stop
670 sleep 3
671 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {}
672 $SUDO service salt-master start
673 $SUDO service salt-minion start
674 sleep 10
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200675 $SUDO salt-call ${SALT_OPTS} saltutil.sync_all >/dev/null
676
677 verify_salt_master
678 set +e
679
680}
681
682
683function verify_salt_master() {
684 set -e
685
686 log_info "Verify Salt master"
687 test -n "$MASTER_HOSTNAME" || exit 1
688
689 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
Petr Michaleca5141342017-08-16 12:55:20 +0200690 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_yaml > /tmp/${MASTER_HOSTNAME}.reclass.validate_yaml
691 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_pillar > /tmp/${MASTER_HOSTNAME}.reclass.validate_pillar
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200692 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} grains.item roles > /tmp/${MASTER_HOSTNAME}.grains.item.roles
693 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} state.show_lowstate > /tmp/${MASTER_HOSTNAME}.state.show_state
694 $SUDO salt-call --no-color grains.items
695 $SUDO salt-call --no-color pillar.data
696 fi
Petr Michaleca5141342017-08-16 12:55:20 +0200697 # TODO: REMOVE reclass --nodeinfo section / run only on debug - as the only required is reclass.validate_*
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200698 if ! $SUDO reclass --nodeinfo ${MASTER_HOSTNAME} > /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo; then
699 log_err "For more details see full log /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo"
700 exit 1
701 fi
702}
703
704function verify_salt_minion() {
705 set -e
706 node=$1
707 log_info "Verifying ${node}"
708 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
709 $SUDO salt-call ${SALT_OPTS} --id=${node} grains.item roles > /tmp/${node}.grains.item.roles
710 $SUDO salt-call ${SALT_OPTS} --id=${node} state.show_lowstate > /tmp/${node}.state.show_lowstate
711 fi
712 if ! $SUDO reclass --nodeinfo ${node} > /tmp/${node}.reclass.nodeinfo; then
713 log_err "For more details see full log /tmp/${node}.reclass.nodeinfo"
714 if [[ ${BREAK_ON_VERIFICATION_ERROR:-yes} =~ ^(True|true|1|yes)$ ]]; then
715 exit 1
716 fi
717 fi
718}
719
720function verify_salt_minions() {
721 #set -e
Petr Michalec679f15b2017-09-18 16:16:29 +0200722 NODES=$(find $RECLASS_ROOT/nodes/_generated/ -name "*.yml" | grep -v "cfg")
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200723 log_info "Verifying minions: $(echo ${NODES}|xargs)"
724
725 # Parallel
726 #echo $NODES | parallel --no-notice -j 2 --halt 2 "verify_salt_minion \$(basename {} .yml) > {}.pillar_verify"
727 #ls -lrta *.pillar_verify | tail -n 1 | xargs -n1 tail -n30
728
729 function filterFails() {
730 grep -v '/grains' | tee -a $1 | tail -n20
731 }
732
733 log_info "Verify nodes"
734 passed=0
735 for node in ${NODES}; do
736 node=$(basename $node .yml)
737
738 # filter first in cluster.. ctl-01, mon-01, etc..
739 if [[ "${node//.*}" =~ 01 || "${node//.*}" =~ 02 ]] ;then
740 verify_salt_minion ${node} || continue
741 else
742 echo Skipped $node.
743 fi
744 passed=$(($passed+1))
745 done
746 # fail on failures
747 total=$(echo $NODES | xargs --no-run-if-empty -n1 echo |wc -l)
748 test ! $passed -lt $total || log_err "Results: $passed of $total passed."
749 test ! $passed -lt $total || {
750 tail -n50 /tmp/*.pillar_verify
751 return 1
752 }
753}
754
755
756
757##########################################
758# To install salt master/minon
759
760function install() {
761 setup $@
762}
763
764function setup() {
765 # CLI
766 while [ x"$1" != x"" ]; do
767 which curl &>/dev/null || $PKGTOOL -y install curl &>/dev/null
768
769 case $1 in
770 master )
771 install_salt_master_$SALT_SOURCE
772 install_salt_minion_$SALT_SOURCE
773 install_salt_formula_$FORMULAS_SOURCE
774 ;;
775 minion )
776 install_salt_minion_$SALT_SOURCE
777 ;;
778 esac
779 shift
780 done
781 echo DONE
782}
783
784function bootstrap() {
785 log_info "Bootstrap & verification of SaltMaster and configured minions."
786 trap _atexit INT TERM EXIT
787
788 system_config_master
789 saltmaster_bootstrap &&\
Petr Michalec58575b92017-08-20 10:42:25 +0200790 saltmaster_init #&&\
Petr Michaleca5141342017-08-16 12:55:20 +0200791 #verify_salt_minions
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200792}
793
794function default() {
795 bootstrap $@
796}
797
798
799##########################################
800[[ "$0" != "$BASH_SOURCE" ]] || {
801# unless file is being sourced
802 default $@
803}